// --------------------------------------------------------------------------
// Dingus project - a collection of subsystems for game/graphics applications
// Developed by nesnausk! team: www.nesnausk.org
// --------------------------------------------------------------------------

#ifndef __PORTAL_STAGE_H
#define __PORTAL_STAGE_H

#include "../pipeline/PipelineStage.h"

namespace dingus {

class CPortalContext;


class CPortalStage : public IPipelineStage {
public:
	explicit CPortalStage( CPortalContext& ctx ) : mCtx(&ctx) { };
	virtual ~CPortalStage() { };

	// IPipelineStage
	virtual void perform();

	void setContext( CPortalContext& ctx ) { mCtx = &ctx; };
	CPortalContext* getContext() const { return mCtx; };
	
private:
	CPortalContext*	mCtx;
};


}; // namespace

#endif
